local DefileCalendar = {
  frame = CreateFrame("Frame"),
  set = 0  
}

DefileCalendar_EventRowArray = {}             

defileCaldendarFrame_Updatehooksw = false

DefileCalendar.frame:SetScript("OnEvent", function(self, event, ...)
	if event == "PLAYER_ENTERING_WORLD" and DefileCalendar.set == 0 then
		DefileCalendar.set = 1
		if not defileCaldendarFrame_Updatehooksw then
			ToggleCalendar()
			ToggleCalendar()
			CalendarFrame:HookScript("OnShow", showDefileCalendar)
			CalendarFrame:HookScript("OnHide", hideDefileCalendar)
			defileCaldendarFrame_Updatehooksw = true
		end
	end

	if event == "CALENDAR_ACTION_PENDING" and CalendarIsActionPending() == false then
	end
end)
      
function loadDefileEvents()
	local i,j,b,numItems
	numItems = 0
	for j = 1, 31, 1 do
		local i = CalendarGetNumDayEvents(0, j)
		if i > 0 then
			for b = 1, i, 1 do
				local title, hour, minute, calendarType, sequenceType, eventType, texture, _, inviteStatus = CalendarGetDayEvent(0, j, b)
				if calendarType == "GUILD_EVENT" then
					numItems = numItems + 1
					local temp = createGuildEventRow(title, j, b)
					temp.frame:ClearAllPoints()
					if numItems == 1 then
						temp.frame:SetPoint("TOPLEFT", DefileCalendar_Main, "TOPLEFT", 15 , -35)
					else
						temp.frame:SetPoint("TOPLEFT", DefileCalendar_Main, "TOPLEFT", 15 , numItems * -35)
					end
					temp.frame.EventName:SetText(title)
					temp.frame.EventTexture:SetTexture("Interface\\LFGFrame\\LFGIcon-"..texture)
					if minute == 0 then
						minute = "00"
					end
					if hour > 12 then
						hour = hour - 12 .. ":" .. minute .. " pm"
					else
						hour = hour .. ":" .. minute .. " am"
					end
					temp.frame.EventTime:SetText(hour)

					if inviteStatus == 7 then
						temp.frame.EventSignup:SetText("Cancel Signup")
					else
						temp.frame.EventSignup:SetText("Sign Up")
					end

					temp.frame.EventSignup:RegisterForClicks("AnyUp")
					temp.frame.EventSignup:SetScript("OnClick", function (self, button, down) 
						if self:GetText() == "Sign Up" then
							signupForEvent(j, b)
							self:SetText("Cancel Signup")
						else
							cancelSignupForEvent(j, b)
							self:SetText("Sign Up")
						end
					end)

					temp.frame.EventMembers:SetScript("OnEnter", function (...)
						queryDefileEventMembers(j, b)
					end)

					temp.frame:Show()
				end	
			end
		end
	end
	
end

function showDefileCalendar()
	loadDefileEvents()
	DefileCalendar_Main:ClearAllPoints()
	DefileCalendar_Main:SetPoint("TOPLEFT", "CalendarFrame", "TOPRIGHT", 0, -10)
	DefileCalendar_Main:SetPoint("BOTTOMLEFT", "CalendarFrame", "BOTTOMRIGHT", 0, -10)
	DefileCalendar_Main:Show()
end

function hideDefileCalendar()
	DefileCalendar_Main:Hide()
	for key,value in pairs(DefileCalendar_EventRowArray) do
		if value ~= nil then
			value.frame:Hide()
			value.inUse = false
		end
	end
end

function signupForEvent(EventDay, EventIndex)
	CalendarContextEventSignUp(0, EventDay, EventIndex)
end

function cancelSignupForEvent(EventDay, EventIndex)
	CalendarContextInviteRemove(0, EventDay, EventIndex)
end

function queryDefileEventMembers(EventDay, EventIndex)
	CalendarOpenEvent(0, EventDay, EventIndex)
end

function createGuildEventRow(EventName, EventDay, EventIndex)
	for key,value in pairs(DefileCalendar_EventRowArray) do
		if value.inUse == false then
			value.inUse = true
			value.eventName = EventName
			value.eventDay = EventDay
			value.eventIndex = EventIndex
			return value
		end
	end
	
	--Made it all the way to the end without finding a false value. So we have to create a new value and add it to the array	
	local DefileCalendar_EventRow = {
		frame = CreateFrame("Frame", "DefileCalendar_ListRow"..EventDay..EventIndex, DefileCalendar_Main_ScrollFrame, "DefileCalendar_ListRow"),
		inUse = true,
		eventName = EventName,
		eventDay = EventDay,
		eventIndex = EventIndex
	}

	table.insert(DefileCalendar_EventRowArray, DefileCalendar_EventRow)

	return DefileCalendar_EventRow
end

DefileCalendar.frame:RegisterEvent("PLAYER_ENTERING_WORLD");
DefileCalendar.frame:RegisterEvent("CALENDAR_ACTION_PENDING");
